<?php
require_once($_SERVER["DOCUMENT_ROOT"]."/lgwebapp.inc");
require_once($path_common."/sitepage.inc");
require_once($path_layout."/resultslayout.inc");
require_once($path_layout."/detailslayout.inc");
require_once($path_common."/sample.inc");

class LayoutDemoPage extends SitePage
{
   protected $type;

   public function __construct()
   {
      parent::__construct();

      $this->init();
   }

   public function get_css_linked()
   {
      return array
      (
         "sitewide.css",
         "laydemos.css"
      );
   }

   public function get_content()
   {
      switch ($this->type)
      {
         case "laydtl":
            $content = $this->get_laydtl_demo();
            break;

         default:
            $content = $this->get_layres_demo();
      };

      return $content;
   }

   protected function get_laydtl_demo()
   {
      // Create multiple instances of a sample module to populate the page.
      $mod = new SampleModule($this, "hdr");
      $hdr = $mod->create();

      $mod = new SampleModule($this, "ldr");
      $ldr = $mod->create();

      $mod = new SampleModule($this, "latpri", 300);
      $latpri = $mod->create();

      $mod = new SampleModule($this, "latsec", 300);
      $latsec = $mod->create();

      $mod = new SampleModule($this, "sec", 470);
      $sec = $mod->create();

      $mod = new SampleModule($this, "ter");
      $ter = $mod->create();

      $mod = new SampleModule($this, "ftr1");
      $ftr1 = $mod->create();

      $mod = new SampleModule($this, "ftr2");
      $ftr2 = $mod->create();

      // Place the sample modules within the overall layout for the page.
      $mod = new DetailsLayout
      (
         $this,
         array($hdr),
         array($ldr),
         array($latpri),
         array($latsec),
         array($sec),
         array($ter),
         array($ftr1),
         array($ftr2)
      );

      return $mod->create();
   }

   protected function get_layres_demo()
   {
      // Create multiple instances of a sample module to populate the page.
      $mod = new SampleModule($this, "hdr");
      $hdr = $mod->create();

      $mod = new SampleModule($this, "pri", 300);
      $pri = $mod->create();

      $mod = new SampleModule($this, "sec", 300);
      $sec = $mod->create();

      $mod = new SampleModule($this, "ter");
      $ter = $mod->create();

      $mod = new SampleModule($this, "ftr1");
      $ftr1 = $mod->create();

      $mod = new SampleModule($this, "ftr2");
      $ftr2 = $mod->create();

      // Place the sample modules within the overall layout for the page.
      $mod = new ResultsLayout
      (
         $this,
         array($hdr),
         array($pri),
         array($sec),
         array($ter),
         array($ftr1),
         array($ftr2)
      );

      return $mod->create();
   }

   public function title()
   {
      $this->title = "Layout Demo";
   }

   public function set_css_id()
   {
      // Support multiple demos from this page. This sets the scope for CSS.
      switch ($this->type)
      {
         case "laydtl":
            $this->css_id = "laydtldemo";
            break;

         default:
            $this->css_id = "layresdemo";
      };
   }

   private function init()
   {
      if (!empty($_GET["type"]))
         $this->type = $_GET["type"];
      else
         $this->type = "layres";
   }
}
?>
